#--------------------------------------------
#
# Display Module ver 2.10
#
#  ev[go͂\pW[
#--------------------------------------------

#-----------------------------------------------------------
# MjDisp NX
#-----------------------------------------------------------

package MjDisp;


# Document ̍쐬
sub createDocument(;$$){
	my($title, $plate) = @_;
	my $doc =  new MjDisp::Document($title, $plate);
  $doc->{'home'} = $doc;
  return $doc;
}

package MjDisp::Template;

$TEMPLATE_PATH = "./template/";

#-----------------------------------------------------------
# Template NX
#-----------------------------------------------------------


#-----------------------------------------#
# RXgN^
#-----------------------------------------#
sub new{
	my $this = shift;
	my($plate) = @_;
	my $member = {
		template => $plate,
		tr       => undef,
		sub      => undef,
		child    => {},
		path     => "./template/",
    home     => undef,
	};
	bless $member,$this;
	return $member;
}


#-----------------------------------------#
# ϊXg̒ǉ
#-----------------------------------------#
sub setText{
	my $this = shift;
	my($key,$val) = @_;
	$this->{tr}->{$key} = $val;
	return $this->{tr}->{$key};
}

#-----------------------------------------#
# ϊe̒ǉ
#-----------------------------------------#
sub addText{
	my $this = shift;
	my($key,$val) = @_;
	$this->{tr}->{$key} .= $val;
	return $this->{tr}->{$key};
}

#-----------------------------------------#
# qev[g̒ǉ
#-----------------------------------------#
sub append{
	my $this = shift;
	my($key,$val) = @_;
	push @{$this->{child}->{$key}}, $val;
  return scalar @{$this->{child}->{$key}};
}


#-----------------------------------------#
# ev[gϊ
#-----------------------------------------#
sub transform{
	my $this = shift;
	if(@_){$this->template($_[0]);}

	# qev[gKwIɕϊ
	while(my($key,$val) = each %{$this->{child}}){
		foreach(@{$val}){
			if(ref $_){ $this->addText($key, $_->transform); }
			else{ $this->addText($key, $_); }
		}
	}

  # ϊ܂
  $this->{template} =~ s#::#/#ig;
  my $flTemp  = $this->{path} . $this->template . ".htt";
  return $this->_transTemplate($flTemp,$this->{tr});
}


#-----------------------------------------#
# ANZT
#-----------------------------------------#
sub template{
	my $this = shift;
	if(@_){$this->{template} = $_[0];}
	return $this->{template};
}

# Private \bh

#-----------------------------------------#
# ev[gϊíj
#-----------------------------------------#
sub _transTemplate($$){
	my $this = shift;
	my($name,$list) = @_;
  my $template;
  my $cache = \$this->{'home'}->{'temporary'}->{$name};
  
  if(!$$cache){

    # LbV
    if(-f $name){
      sysopen(TMP,$name,O_RDONLY);
      local($/) = undef;
			$template = <TMP>;
      close(TMP);
      $$cache = $template;
    }
    else{
      print 'FileOpenError -- ' . $name . "\n";
      return undef;
    }
  }
  else{
    # LbV𗘗p
    $template = $$cache;
  }

  # ϊ܂
  $template =~ s/\$\{([A-Za-z_]+)\}/my $value = $list->{$1};$value;/ge;
  return $template;
}


#-----------------------------------------------------------
# DocumentNX
#-----------------------------------------------------------
package MjDisp::Document;

use base qw(MjDisp::Template);

sub new{
	my $this = shift;
	my($title, $plate) = @_;
	my $member = {
		template => $plate,
		tr       => undef,
		sub      => undef,
		child    => {},
		title    => $title,
		path     => "./template/",
		encode   => "Shift_JIS",
    temporary => undef,
	};
	if(!defined($plate)){ $member->{'template'} = 'root'; }
	bless $member,$this;
	return $member;
}

#-----------------------------------------#
# ʂɏo
#-----------------------------------------#
sub write{
	my $this = shift;
	$this->setText("Title", $this->title);
	$this->setText("Encode", $this->encode);
	print $this->_printHTTPHeader;
	print $this->transform;
}

#-----------------------------------------#
# HTTPX|Xwb_̏o
#-----------------------------------------#
sub _printHTTPHeader(@){
	my $this = shift;
	my @header = (
		q(Content-Type:text/html; charset=) . $this->encode,
	);
	my @cache = (
		q(Pragma: no-cache),
		q(Cache-Control: no-cache),
		q(Expires: Thu, 01 Dec 1994 16:00:00 GMT)
	);
	@header = (@header,@_);
	my $head = "";
	foreach(@header){$head .= $_ . "\n";}
	$head .= "\n";
	return $head;
}

#-----------------------------------------#
# X^CV[g̒ǉ
#-----------------------------------------#
sub style($){
	my $this = shift;
	my($path) = @_;
	my $tmpLink = '<link rel="stylesheet" href="' . $path . '" type="text/css" media="screen,tv" />';
	$this->append('CSS', $tmpLink);
}

#-----------------------------------------#
# XNvg̒ǉ
#-----------------------------------------#
sub script($){
	my $this = shift;
	my($path) = @_;
	my $tmpLink = '<script type="text/javascript" src="' . $path . '"></script>';
	$this->append('Script', $tmpLink);
}

#-----------------------------------------#
# Vev[g̍쐬
#-----------------------------------------#
sub createTemplate($){
	my $this = shift;
	my($plate) = @_;
	my $myTemp = new MjDisp::Template($plate);
  $myTemp->{'home'} = $this;
	return $myTemp;
}

#-----------------------------------------#
# ANZT
#-----------------------------------------#
sub title{
	my $this = shift;
	if(@_){$this->{title} = $_[0];}
	return $this->{title};
}

sub encode{
	my $this = shift;
	if(@_){$this->{encode} = $_[0];}
	return $this->{encode};
}


# Vvf̍쐬
sub createElement{
	my $this = shift;
	my($nodeName) = @_;
	my $myElm = MjDisp::Element::new("MjDisp::Element", $nodeName);
  $myElm->{'home'} = $this;
  return $myElm;
}


# appendI[o[Ch
sub append{
  my $this = shift;
  my $key = "Body";
  my $val = $_[0];
  if(scalar @_ >= 2){ $key = $_[0]; $val=$_[1]; }
  $this->SUPER::append($key, $val);
}

#-----------------------------------------------------------
#-----------------------------------------------------------
# ElementNX
#-----------------------------------------------------------
#-----------------------------------------------------------

package MjDisp::Element;

use base qw(MjDisp::Template);


sub new{
	my $this = shift;
	my($name) = @_;
	my $member = {
		name     => $name,
		child    => [],
		attr     => {},
	};
	bless $member,$this;
	return $member;
}

# ANZT
sub name($){
	my $this = shift;
	if(@_){$this->{name} = $_[0];}
	return $this->{name};
}

# ̃Zbg
sub setAttribute($$){
	my $this = shift;
	my($key, $value) = @_;
	$this->{attr}->{$key} = $value;
	return $this->{attr}->{$key};
}

# eLXgm[hZbg
sub append($){
	my $this = shift;
	my($text) = @_;
	push @{$this->{child}}, $text;
	return;
}


# vf𕶎
sub transform(){
	my $this = shift;
	my $xml = '<' . $this->name;
	# t
	while(my($key, $val) = each %{$this->{attr}}){
		$xml .= ' ' . $key . '="' . $val . '"';
	}
	# eWJ
	if(scalar @{$this->{child}}){
		$xml .= '>';
		foreach(@{$this->{child}}){
			if(ref $_){ $xml .= $_->transform; }
			else{ $xml .= $_; }
		}
		$xml .= '</' . $this->name . '>' . "\n";
	}
	else{
		$xml .= ' />';
	}
}


